<template>
  <div class="page-body">
    <div class="page-content">
      <q-table :pagination="msg" :loading="loading" no-data-label="暂无相关数据" flat
        class="sticky-column-table" separator="none" :data="dataList" :columns="columns"
        row-key="name">
        <template v-slot:top="props">
          <div class="col-2 q-table__title">客户需求</div>
          <q-space />
          <div class="page-option">
            <q-btn color="accent" size="sm" class="q-mr-md" icon="add" label="新增阶段" @click="addObj(null)" />
          </div>
        </template>
        <template v-slot:body-cell-Group_Id="props">
          <q-td :props="props">
            <div>
              <q-btn flat size="xs" icon="edit" color="accent" style="font-weight:400" label="编辑"
                @click="addObj(props.row)" />
              <q-btn flat size="xs" icon="delete" color="negative" class="q-mr-xs" label="删除"
                @click="deletNeed(props.row.Id)" />
            </div>
          </q-td>
        </template>
        <template v-slot:bottom>
          <q-pagination class="full-width justify-end" v-model="msg.pageIndex" color="primary" :max="pageCount"
            :input="true" @input="changePage" />
        </template>
      </q-table>
    </div>
    <customneed-form v-if="isShowNeedForm" :save-obj="customObj" @close="closestageForm" @success="refreshPage">
    </customneed-form>
  </div>
</template>

<script>
  import {
    GetNeedsPage,
    RemoveNeeds
  } from '../../api/system/index'
  import customneedForm from '../../components/system/customneed-form'
  export default {
    meta: {
      title: "客户需求"
    },
    components: {
      customneedForm
    },
    data() {
      return {
        columns: [{
            name: 'Id',
            label: 'Id',
            field: row => row.Id,
            align: 'left'
          },{
            name: 'Name',
            label: '需求',
            field: 'Name',
            align: 'left'
          },{
            name: 'CreateByName',
            label: '创建人',
            align: 'left',
            field: 'CreateByName'
          },{
            name: 'CreateTime',
            label: '创建时间',
            align: 'left',
            field: 'CreateTime'
          },{
            name: 'Group_Id',
            label: '操作',
            field: 'Group_Id'
          }
        ],
        msg:{
          pageIndex:1,
          pageSize:12,
          Name:"",
          rowsPerPage: 12
        },
        dataList: [],
        pageCount:0,
        loading: true,
        isShowNeedForm: false,
        customObj: {}
      }
    },
    mounted() {
      this.getList()
    },
    methods: {
      //翻页
      changePage(val) {
        this.msg.pageIndex = val;
        this.getList()
      },
      deletNeed(Id) {
        let delMsg = {
          Id: Id
        };
        this.$q.dialog({
          title: '提示信息',
          message: '是否确定该需求？',
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          RemoveNeeds(delMsg).then(res => {
            if (res.Code == 1) {
              this.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '删除成功！',
                position: 'top'
              })
              this.getList();
            }
          })
        }).onCancel(() => {

        });
      },
      getList() {
        this.loading = true;
        GetNeedsPage(this.msg).then(res => {
          this.loading = false;
          if(res.Code==1){
            this.dataList = res.Data.PageData;
            this.pageCount = res.Data.PageCount;
          }
        })
      },
      closestageForm() {
        this.isShowNeedForm = false
      },
      refreshPage(){
        this.getList();
      },
      addObj(obj){
        if (obj) {
          this.customObj = obj
        } else {
          this.customObj = null
        }
        this.isShowNeedForm = true;
      }
    },
  }

</script>

<style lang="sass">
  @import url('~assets/css/table.sass')

</style>
